"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _useCatalog = _interopRequireDefault(require("./use-catalog"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var CatalogComponent = function CatalogComponent(props) {
  var component = props.component,
      FallbackComponent = props.fallbackComponent,
      others = _objectWithoutProperties(props, ["component", "fallbackComponent"]);

  var _ref = (0, _useCatalog.default)() || {},
      catalog = _ref.catalog;

  if (!catalog || !catalog._components) {
    console.error('catalog is not defined. Please use <CatalogComponent /> in the context of a <CatalogProvider /> with an existing catalog.');
    return null;
  }

  var Component = catalog._components[component];

  if (Component) {
    return _react.default.createElement(Component, others);
  }

  if (FallbackComponent) {
    return _react.default.createElement(FallbackComponent, others);
  }

  console.warn("No component for \"".concat(component, "\" was found in the component catalog. The catalog contains the following components:"), catalog._components && Object.keys(catalog._components));
  return null;
};

var _default = CatalogComponent;
exports.default = _default;