"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _catalog = _interopRequireDefault(require("../lib/catalog"));

var _catalogContext = _interopRequireDefault(require("./catalog-context"));

var _useCatalog = _interopRequireDefault(require("./use-catalog"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var CatalogProvider = function CatalogProvider(props) {
  var _props$catalog = props.catalog,
      catalog = _props$catalog === void 0 ? {} : _props$catalog,
      _props$catalogPrefix = props.catalogPrefix,
      catalogPrefix = _props$catalogPrefix === void 0 ? '' : _props$catalogPrefix,
      children = props.children;

  var _ref = (0, _useCatalog.default)() || {},
      outerCatalog = _ref.catalog;

  var prefixedCatalog = null;

  if (catalogPrefix && catalog._components) {
    var components = {};
    Object.keys(catalog._components).map(function (c) {
      components["".concat(catalogPrefix).concat(c)] = catalog._components[c];
    });
    prefixedCatalog = new _catalog.default({
      components: components
    });
  }

  var prepCatalog = prefixedCatalog || catalog;

  if (outerCatalog) {
    prepCatalog = new _catalog.default({
      components: _objectSpread({}, outerCatalog && outerCatalog._components, prepCatalog && prepCatalog._components)
    });
  }

  return _react.default.createElement(_catalogContext.default.Provider, {
    value: {
      catalog: prepCatalog
    }
  }, _react.default.Children.only(children));
};

var _default = CatalogProvider;
exports.default = _default;