"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.withCatalog = exports.getDisplayName = void 0;

var _react = _interopRequireDefault(require("react"));

var _hoistNonReactStatics = _interopRequireDefault(require("hoist-non-react-statics"));

var _useCatalog = _interopRequireDefault(require("./use-catalog"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var getDisplayName = function getDisplayName(Component) {
  return Component.displayName || Component.name || 'Component';
};

exports.getDisplayName = getDisplayName;

var withCatalog = function withCatalog(Component) {
  var WithCatalog = function WithCatalog(props) {
    var catalog = (0, _useCatalog.default)();
    return _react.default.createElement(Component, _extends({}, props, {
      catalog: catalog && catalog.catalog
    }));
  };

  WithCatalog.displayName = "WithCatalog(".concat(getDisplayName(Component), ")");
  (0, _hoistNonReactStatics.default)(WithCatalog, Component);
  return WithCatalog;
};

exports.withCatalog = withCatalog;
var _default = withCatalog;
exports.default = _default;